/*	converters.c

	̃vÓApcmplay.xōsAoblf[^tH[}bgRo[^LqĂ܂B

 $Id: converters.c,v 1.2 1994/08/31 23:12:30 Kohju Exp $
 $Header: a:/usr/home/Kohju/Labo/PCMPLAY/converters.c,v 1.2 1994/08/31 23:12:30 Kohju Exp $
 $Log: converters.c,v $
 * Revision 1.2  1994/08/31  23:12:30  Kohju
 * EBW`FbN[`̒ǉB
 *
 * Revision 1.1  1994/08/31  19:51:58  Kohju
 * Initial revision
 *

*/

#include	<stdio.h>
#include	"pcmplay.h"


void	pn8topc8(void *p,int len)
{
	unsigned char	*cp=p;
			 int	i;

	for(i=0;i<=len-1;i++,cp++)
		(char)*cp = (char)(*cp-0x80);
}

void	ps8topc8(void *p,int len)
{
	unsigned char	*cp=p;
			 int	i;

	for(i=0;i<=len-1;i++){
		if( *cp >= 0x80 ) *cp = 0x80 - *cp;
		cp++;
	}
}

void	ps8topn8(void *p,int len)
{
/*	AD558̃f[^tH[}bg$00-$ff̐`łB
	ps8`́AMSBTCrbg8bitPCMłB

	āAf[^Veȉ̎A
		f[^́WOグB
	tɁA@f[^WOȏ̎A
		f[^́WOAi|tj
		@@@@WOグB					*/

	unsigned char	*cp=p;
			 int	i;

	for(i=0;i<=len-1;i++){
		if( *cp >= 0x80 ) *cp = 0x80 - *cp;	// B
		*cp += 0x80;	// 80グ
		cp++;
	}
	return;
}

void	lh_bitconv(void *p2,void *p,int len)
{
//	PCE`PCMt@CAX68kPCM`ɃfR[h
	char	*cp =p;
	char	*cp2=p2;
	char	temph=0;
	char	templ=0;
	int	i;

	for(i=0;i<=len;i++,cp++,cp2++){
		templ=((*cp & 0x0f) << 4);
		temph=((*cp & 0xf0) >> 4);
		*cp2=(temph | templ);
	}
}

void	pc8topn8(void *p,int len)
{
/*
	(unsigned char)-0x80āA(char)ɃLXgB
*/

	unsigned char	*cp=p;
			 int	i;

	for(i=0;i<=len-1;i++){
		*cp = (char)((*cp)- 0x80);
		cp++;
	}
	return;
}


void	endianconv(void *p2,void *p,int len)
{
//	GfBARo[gB

	short int	*cp =p;
	short int	*cp2=p2;
	short int	temph=0;
	short int	templ=0;
	int	i;

	for(i=0;i<=len;i++,cp++,cp2++){
		templ=((*cp & 0x00ff) << 8);
		temph=((*cp & 0xff00) >> 8);
		*cp2=(temph | templ);
	}
}

void	pc8top16(void *p2,void *p,int len)
{
/*	t8bitPCM𕄍t16bitPCMɕϊB

	p2ɏo͂pcm̃AhXi16rbgj֐ĂԎɁAlen̂Q{̒mۂĂƁB
	pɓ͂pcm̃AhXi16rbgj
	len͓͂pcm̒B
*/
	char		*cp =p;
	short int	*cp2=p2;
	int	i;

	for(i=0;i<=len;i++){
		*cp2=(short int)((*cp)*8);
		cp++;
		cp2++;
	}
}


void	p16topc8(void *p2,void *p,int len)
{
/*	t8bitPCM𕄍t16bitPCMɕϊB

	p2ɏo͂pcm̃AhXi16rbgj֐ĂԎɁAlen̂Q{̒mۂĂƁB
	pɓ͂pcm̃AhXi16rbgj
	len͓͂pcm̒B
*/
	short int	*cp =p;
	char		*cp2=p2;
	int	i,s=8;

	for(i=0;i<=len;i++){				// s{Ƃ~lȁBȏ͉ƁB
		if(*cp> 1023) *cp = 128*s-1;
		if(*cp<-1024) *cp =-128*s;
		*cp2=(char)((*cp)/s);
		cp++;
		cp2++;
	}
}

void	RCSCONVERTERS( void )
{
	printf("converters.c = $Id: converters.c,v 1.2 1994/08/31 23:12:30 Kohju Exp $\n");
}
